-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PreparePalsMenu()
-- DESC : Builds Right Click Interactive Menu
-- **************************************************************************
function TitanPanelRightClickMenu_PreparePalsMenu()
     local info = {};
     local CurCounts = TitanPanelPals_GetButtonCounts();
     local NumPals, NumPalsOnline = string.match( CurCounts, '(.*):(.*)' )
     -- Start Menu 2
     if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then
          -- this is for whispering a friend
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_WHISPER"] ) then
               TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_WHISPER"], UIDROPDOWNMENU_MENU_LEVEL);
               local NumPals = GetNumFriends();
               local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
               local friendIndex
               for friendIndex=1, NumPals do
                    Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
                    if ( Pals_connected ) then
                         info = {};
                         info.text = TitanPanelPals_ColorUtils("GetCClass", "color", Pals_class, Pals_name);
                         info.func = palsWisper;
                         info.value = Pals_name;
                         UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    end
               end
          end
          -- this is for removing a friend from friends list
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVE"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_REMOVE"], UIDROPDOWNMENU_MENU_LEVEL);
               local NumPals = GetNumFriends();
               local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
               local friendIndex
               for friendIndex=1, NumPals do
                    Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
                    if ( Pals_connected ) then
                         info = {};
                         info.text = TitanPanelPals_ColorUtils("GetCClass", "color", Pals_class, Pals_name);
                         info.func = PalsRemove;
                         info.value = Pals_name;
                         UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    end
               end
          end
          -- This is for group Invites
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_INVITE"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_INVITE"], UIDROPDOWNMENU_MENU_LEVEL);
               local NumPals = GetNumFriends();
               local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
               local friendIndex
               for friendIndex=1, NumPals do
                    Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
                    if ( Pals_connected ) then
                         info = {};
                         info.text = TitanPanelPals_ColorUtils("GetCClass", "color", Pals_class, Pals_name);
                         info.func = PalsInvite;
                         info.value = Pals_name;
                         UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    end
               end
          end
          -- This is for setting friends note
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_NOTE"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_NOTE"], UIDROPDOWNMENU_MENU_LEVEL);
               local NumPals = GetNumFriends();
               local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
               local friendIndex
               for friendIndex=1, NumPals do
                    Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
                    if ( Pals_connected ) then
                         info = {};
                         info.text = TitanPanelPals_ColorUtils("GetCClass", "color", Pals_class, Pals_name);
                         info.hasArrow = 1;
                         UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    end
               end
          end
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_SYNC"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_SYNC"], UIDROPDOWNMENU_MENU_LEVEL);
               -- Sync Alts To Friends List Setting Option
               info = {};
               info.text = LB["TITAN_PALS_MENU_SYNCALTS"];
               info.func = TitanPanelPals_SyncAlts;
               UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
               -- Sync Alts To Friends List Setting Option
               info = {};
               info.text = LB["TITAN_PALS_MENU_SYNCALTSFRIENDS"];
               info.func = TitanPanelPals_SyncAltsFriends;
               UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	  end
          if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_DEBUG_MDEBUG"] ) then
                    TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_DEBUG_DEBUG1"], UIDROPDOWNMENU_MENU_LEVEL);
                    info = {};
                    info.text = LB["TITAN_PALS_DEBUG_DEV"];
                    info.func = TitanPals_DevDebug;
                    info.checked = TitanPals["Debug"];
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    info = {};
                    info.text = LB["TITAN_PALS_DEBUG_DEVEVENT"];
                    info.func = TitanPals_DevDebugEvent;
                    info.checked = TitanPals["DebugEvent"];
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
                    info = {};
                    info.text = LB["TITAN_PALS_DEBUG_DEVLOGEVENT"];
                    info.func = TitanPals_DevDebugLogEvent;
                    info.checked = TitanPals["DebugLogEvent"];
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
		    TitanPanelRightClickMenu_AddSpacer(UIDROPDOWNMENU_MENU_LEVEL);
		    TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_DEBUG_PLAY"], UIDROPDOWNMENU_MENU_LEVEL);
		    info = {};
		    info.text = LB["TITAN_PALS_DEBUG_PLAYFRIENDS"];
		    info.func = TitanPals_MenuProssess;
		    info.value = "playFriends";
		    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
		    info = {};
		    info.text = LB["TITAN_PALS_DEBUG_PLAYALTS"];
		    info.func = TitanPals_MenuProssess;
		    info.value = "playAlts";
		    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
          end
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVEDATA"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_REMOVEDATA"], UIDROPDOWNMENU_MENU_LEVEL);
	       -- Outdated Friends
               info = {};
	       info.text = LB["TITAN_PALS_MENU_REMOVE_FRIEND"];
	       info.hasArrow = 1;
	       UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	       -- Outdated Alts
	       info = {};
	       info.text = LB["TITAN_PALS_MENU_REMOVE_ALT"];
	       info.hasArrow = 1;
	       UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	  end
          return;
     end
     -- End Menu 2
     -- Start Menu 3
     if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVE_FRIEND"] ) then
               TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_REMOVE_FRIENDDATA"], UIDROPDOWNMENU_MENU_LEVEL);
	       local a, b, c, n, v;
	       for n, v in pairs(TitanPals["Lists"][palsDB]) do
                    a, b, c = string.match(v, '(.*):(.*):(.*)');
		    TitanPanelPals_DebugUtils("bug", "menu", "--> = "..v)
		    if ( not TitanPals["Alts"][palsDB][n] ) then
                         info = {};
                         info.text = LB["TITAN_PALS_MENU_SUB_REMOVE"]..TitanPanelPals_ColorUtils("GetCClass", "color", b, n);
                         info.value = "Lists:"..n;
                         info.func = TitanPals_MenuProssess;
                         UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
		    end
	       end
	  end
	  if ( UIDROPDOWNMENU_MENU_VALUE == LB["TITAN_PALS_MENU_REMOVE_ALT"] ) then
	       TitanPanelRightClickMenu_AddTitle(LB["TITAN_PALS_MENU_REMOVE_ALTDATA"], UIDROPDOWNMENU_MENU_LEVEL);
	       local a, b, c, d, n, v;
               for n, v in pairs(TitanPals["Alts"][palsDB]) do
                    if ( TitanPals["Lists"][palsDB][n] ) then 
                         d = TitanPals["Lists"][palsDB][n];
		         a, b, c = string.match(d, '(.*):(.*):(.*)');
			 TitanPanelPals_DebugUtils("bug", "Menu", "D = "..d)
                    end
                    info = {};
                    info.text = LB["TITAN_PALS_MENU_SUB_REMOVE"]..TitanPanelPals_ColorUtils("GetCClass", "color", b, n);
                    info.value = "Alts:"..n;
                    info.func = TitanPals_MenuProssess;
                    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
	       end
	  end
          local NumPals = GetNumFriends();
          local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
          local friendIndex, Realm_name;
          for friendIndex=1, NumPals do
               Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
               if ( UIDROPDOWNMENU_MENU_VALUE == TitanPanelPals_ColorUtils("GetCClass", "color", Pals_class, Pals_name) ) then
                    --Debug line for Notes submenu
                    if ( Pals_connected ) then
                         if ( Pals_class == "Warrior" ) then
                              info = {};
                              --Protection
                              info.text = "|cffc79c6e"..LB["TITAN_PALS_NOTES_WPROT"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PROT"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Arms
                              info.text = "|cffc79c6e"..LB["TITAN_PALS_NOTES_WARMS"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_WARMS"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Fury
                              info.text = "|cffc79c6e"..LB["TITAN_PALS_NOTES_WFURY"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_WFURY"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Mage" ) then
                              info = {};
                              --Fire
                              info.text = "|cff69ccf0"..LB["TITAN_PALS_NOTES_MFIRE"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_MFIRE"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Frost
                              info.text = "|cff69ccf0"..LB["TITAN_PALS_NOTES_MFROS"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_MFROS"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Arcane
                              info.text = "|cff69ccf0"..LB["TITAN_PALS_NOTES_MARCA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_MARCA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Paladin" ) then
                              info = {};
                              --Protection
                              info.text = "|cfff58cba"..LB["TITAN_PALS_NOTES_PPROT"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PPROT"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Holy
                              info.text = "|cfff58cba"..LB["TITAN_PALS_NOTES_PHOLY"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PHOLY"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Retribution
                              info.text = "|cfff58cba"..LB["TITAN_PALS_NOTES_PRETR"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PRETR"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Hunter" ) then
                              info = {};
                              --Beast Mastery
                              info.text = "|cffabd473"..LB["TITAN_PALS_NOTES_HBEAS"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_HBEAS"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Marksmanship
                              info.text = "|cffabd473"..LB["TITAN_PALS_NOTES_HMARK"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_HMARK"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Survival
                              info.text = "|cffabd473"..LB["TITAN_PALS_NOTES_HSURV"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_HSURV"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Rogue" ) then
                              info = {};
                              --Assassination
                              info.text = "|cfffff569"..LB["TITAN_PALS_NOTES_RASSA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_RASSA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Combat
                              info.text = "|cfffff569"..LB["TITAN_PALS_NOTES_RCOMB"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_RCOMB"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Subtlety
                              info.text = "|cfffff569"..LB["TITAN_PALS_NOTES_RSUBT"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_RSUBT"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Priest" ) then
                              info = {};
                              --Shadow
                              info.text = "|cffffffff"..LB["TITAN_PALS_NOTES_PRSHA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PRSHA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Holy
                              info.text = "|cffffffff"..LB["TITAN_PALS_NOTES_PRHOL"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PRHOL"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Discipline
                              info.text = "|cffffffff"..LB["TITAN_PALS_NOTES_PRDIS"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_PRDIS"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Death Knight" ) then
                              info = {};
                              --Blood
                              info.text = "|cffc41f3b"..LB["TITAN_PALS_NOTES_DKBLO"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DKBLO"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Frost
                              info.text = "|cffc41f3b"..LB["TITAN_PALS_NOTES_DKFRO"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DKFRO"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --UnHoly
                              info.text = "|cffc41f3b"..LB["TITAN_PALS_NOTES_DKUNH"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DKUNH"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Druid" ) then
                              info = {};
                              --Balance
                              info.text = "|cffff7d0a"..LB["TITAN_PALS_NOTES_DBALA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DBALA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Feral Combat
                              info.text = "|cffff7d0a"..LB["TITAN_PALS_NOTES_DFERA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DFERA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Restoration
                              info.text = "|cffff7d0a"..LB["TITAN_PALS_NOTES_DREST"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_DREST"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Shaman" ) then
                              info = {};
                              --Elemental
                              info.text = "|cff2459FF"..LB["TITAN_PALS_NOTES_SELEM"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_SELEM"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Enhancement
                              info.text = "|cff2459FF"..LB["TITAN_PALS_NOTES_SENHA"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_SENHA"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Restoration
                              info.text = "|cff2459FF"..LB["TITAN_PALS_NOTES_SREST"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_SREST"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                         if ( Pals_class == "Warlock" ) then
                              info = {};
                              --Elemental
                              info.text = "|cff9482C9"..LB["TITAN_PALS_NOTES_LAFFL"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_LAFFL"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Enhancement
                              info.text = "|cff9482C9"..LB["TITAN_PALS_NOTES_LDEMO"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_LDEMO"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                              --Restoration
                              info.text = "|cff9482C9"..LB["TITAN_PALS_NOTES_LDEST"].."|r";
                              info.func = PalsNote
                              info.value = Pals_name..":"..LB["TITAN_PALS_NOTES_LDEST"];
                              UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
                         end
                    end
               end
          end
          return;
     end
     -- End Menu 3
     TitanPanelRightClickMenu_AddTitle(TitanPlugins[LB["TITAN_PALS_CORE_ID"]].menuText);
     if ( NumPalsOnline > "0" ) then
          -- create the title for the Whisper submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_WHISPER"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton(info);
          -- create the title for the Invite submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_INVITE"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton(info);
          -- create the title for the Ignore submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_REMOVE"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton(info);
          -- create the title for the Note submenu
          info = {};
          info.text = LB["TITAN_PALS_MENU_NOTE"];
          info.hasArrow = 1;
          UIDropDownMenu_AddButton(info);
          TitanPanelRightClickMenu_AddSpacer();
     end
     -- Syncing Alts / Alts Friends
     info = {};
     info.text = LB["TITAN_PALS_MENU_SYNC"];
     info.hasArrow = 1;
     UIDropDownMenu_AddButton(info);
     -- Removing Friends From Database
     info = {};
     info.text = LB["TITAN_PALS_MENU_REMOVEDATA"]
     info.hasArrow = 1;
     UIDropDownMenu_AddButton(info);
     TitanPanelRightClickMenu_AddSpacer();
     -- Debuging Menu
     local TitanUser = TitanPals["Player"].."@"..TitanPals["Realm"];
     for i=1, table.getn(authors) do
          if ( TitanUser == authors[i]) then 
               info = {};
               info.text = LB["TITAN_PALS_DEBUG_MDEBUG"];
               info.hasArrow = 1;
               UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
               TitanPanelRightClickMenu_AddSpacer();
          end
     end
     info = {};
     info.text = LB["TITAN_PALS_MENU_SETTINGS"];
     info.value = LB["TITAN_PALS_MENU_SETTINGS"];
     info.func = function() InterfaceOptionsFrame_OpenToCategory(LB["TITAN_PALS_CONFIG"]) end
     UIDropDownMenu_AddButton(info);
     TitanPanelRightClickMenu_AddSpacer();
     -- Standard Menu
     TitanPanelRightClickMenu_AddToggleIcon(LB["TITAN_PALS_CORE_ID"]);
     TitanPanelRightClickMenu_AddToggleLabelText(LB["TITAN_PALS_CORE_ID"]);
     -- default Titan Panel right-click menu options
     TitanPanelRightClickMenu_AddCommand(L["TITAN_PANEL_MENU_HIDE"], LB["TITAN_PALS_CORE_ID"], TITAN_PANEL_MENU_FUNC_HIDE);
end

-- **************************************************************************
-- NAME : palsWisper()
-- DESC : Opens a wisper with the selected person
-- **************************************************************************
function palsWisper()
	if ( not ChatFrameEditBox:IsVisible() ) then
		ChatFrame_OpenChat("/w "..this.value.." ");
	else
		ChatFrameEditBox:SetText("/w "..this.value.." ");
	end
end

-- **************************************************************************
-- NAME : PalsRemove()
-- DESC : <research>
-- **************************************************************************
function PalsRemove()
     local IgnoreRemove = this.value;
     RemoveFriend( this.value );
end

-- **************************************************************************
-- NAME : PalsInvite()
-- DESC : <research>
-- **************************************************************************
function PalsInvite()
     InviteUnit( this.value );
end

-- **************************************************************************
-- NAME : PalsNote()
-- DESC : <research>
-- **************************************************************************
function PalsNote()
     local Pals_name, Pals_note = string.match( this.value, '(.*):(.*)' );
     SetFriendNotes( Pals_name, Pals_note )
end

-- **************************************************************************
-- NAME : TitanPals_DevDebug()
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebug()
     TitanPanelPals_CoreUtils("Toggle", "Debug")
     TitanPanelButton_UpdateButton(LB["TITAN_PALS_CORE_ID"]);
end

-- **************************************************************************
-- NAME : TitanPals_DevDebugEvent()
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebugEvent()
     TitanPanelPals_CoreUtils("Toggle", "DebugEvent")
     TitanPanelButton_UpdateButton(LB["TITAN_PALS_CORE_ID"]);
end

-- **************************************************************************
-- NAME : TitanPals_DevDebugLogEvent()
-- DESC : <research>
-- **************************************************************************
function TitanPals_DevDebugLogEvent()
     TitanPanelPals_CoreUtils("Toggle", "DebugLogEvent")
     TitanPanelButton_UpdateButton(LB["TITAN_PALS_CORE_ID"]);
end
-- **************************************************************************
-- NAME : TitanPals_MenuProssess()
-- DESC : <research>
-- **************************************************************************
function TitanPals_MenuProssess()
     --[arg1   ]
     --[Command]
     local cmd = this.value;
     local a, b = string.match( cmd, '(.*):(.*)' );
     TitanPanelPals_DebugUtils("bug", "MenuProssess", "Command = "..this.value);
     if ( a and b ) then
          TitanPanelPals_CoreUtils("fixDB", a, b);
     elseif ( cmd == "playFriends" or cmd == "playAlts" ) then
          TitanPanelPals_CoreUtils(cmd);
     else TitanPanelPals_DebugUtils("bug", "MenuProssess", "Menu Prossessing failed.");
     end
end